
;##############################################################################
;$$$	file: Declarem.pb - date: 04:56 p.m. 05/09/2009												$$$
;$$$	author: Gustavo Julio Fiorenza (info@gushh.net || info@gushh.com.ar)	$$$
;$$$					aka: gushh, dagcrack.																					$$$
;$$$ 	description: automagically generates a declaration list for you.			$$$
;##############################################################################

;
; Notice: this tool must be run through the IDE passing %TEMPFILE as the argument,
; You should then reload the source, as a new file (this are options that you'll find in "Configure Tools...")
; I personally set a shortcut as well: CTRL + ALT + D

#TITLE 									= "Declar'em!"
#PATTERN_FIND 					= "[Pp]rocedure(\.[bcwlifqds])?\s+(\w+)\([^\(/)]*\)" ; Thanks to Makoryu from freenode for the help on this one! (I had a lil' typo, truth be told)
#PATTERN_REPLACE				=	"^(p|P)rocedure?"
#STRING_REPLACEMENT			=	"Declare"
#STRING_LINEFEED				=	#CR$+#LF$

If Not CountProgramParameters()
	MessageRequester( #TITLE, "This tool requires an argument (the temporary source path) without this, the tool can't process any data" )
Else
	
	; Read the file into memory, using a string.
	
	Define.s filecontents		= ""
	Define.i cmdstrptr 			= GetCommandLine_() ; I'm not using PB's routine here because there is an issue with paths that contain spaces.
	Define.s filename 			= PeekS( cmdstrptr )
	Define.i fp							= #Null
	
	; clean the filename.
	filename = Trim(Mid( filename, FindString(filename, Chr(34), 2 )+1, Len(filename) )) ; Basically we search for the second quote and we mid and trim the result.
	
	; read it.
	fp = ReadFile(#PB_Any, filename)
	
	If Not IsFile(fp)
		MessageRequester( #TITLE, "An error occured. The file could not be read." + #STRING_LINEFEED + "File: " + filename  )
	Else
		
		While Not Eof(fp)
			filecontents + ReadString(fp) + #STRING_LINEFEED
		Wend
		
		CloseFile(fp)
	EndIf
	
	; Process the actual data.
	
	If Not filecontents
		MessageRequester( #TITLE, "An error occured. No contents were loaded." + #STRING_LINEFEED + "File: " + filename )
	Else
		
		Define.i regex_find 		= CreateRegularExpression(#PB_Any, #PATTERN_FIND)
		Define.i regex_replace 	= CreateRegularExpression(#PB_Any, #PATTERN_REPLACE)
		Define.i iteration			= 0
		Define.s szReturn				= #NULL$
		
		Dim result.s(0)
		
		If Not (regex_find And regex_replace)
			MessageRequester(#TITLE, "An error occured, the regular expressions failed to create.")
		Else
			
		  For iteration=0 To ExtractRegularExpression(regex_find, filecontents, result())-1
		    szReturn + ReplaceRegularExpression(regex_replace, result(iteration), #STRING_REPLACEMENT)
		    szReturn + #STRING_LINEFEED
		  Next
			
			FreeRegularExpression(regex_find)
			FreeRegularExpression(regex_replace)
			
			If szReturn
				
				Define.s result = #STRING_LINEFEED + szReturn + #STRING_LINEFEED + filecontents
				
				fp = OpenFile(#PB_Any, filename)
				If IsFile(fp)
					WriteString(fp, result)
					CloseFile(fp)
				EndIf
				
			EndIf
			
		EndIf
		
	EndIf
	
EndIf






; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 12
; Folding = --
; Executable = Declarem.exe
; EnableCompileCount = 130
; EnableBuildCount = 16